<?php
/* $id: db.php, v. 1.0 2006/11/30 20:13:42 */
/**
 * DB, the Abstract Database Manipulation class
 *
 * PHP Version 4 and 5
 *
 * DB is the backbone of any database classes.  This provide the manipulation
 * and common functions to permite to inherits classes, work with it's respective
 * Database Host. So, if this class have a failure, the entery structure of
 * database collapse.  Is so much important that the update of this parent class
 * will be saving the initial build-in develop.
 *
 * @category   database
 * @package    DB
 * @link       http://www.wallmedia.com/
 * @copyright  Copyright  2006 by Wallmedia, Inc.
 * @author     Wallmedia Developers Staff <devstaff@wallmedia.com>
 * @version    1.0
 * @since      Class with initial release
 * @deprecated Class not deprecated
 */

class db
{
    /**#@+
     * DB Configuration Section:
     *
     * This configuration settings permite optimize and customize the
     * way to work with the class.  This define standar configuration, but
     * for each database driver class, can be changed.
     */
     
    /**
     * Default return var type
     *
     * @var int : resource id (1), array (2), object (3)
     * @access public
     */
    var $return_type = 2;
    
    /**
     * Default array return hash indexes type
     *
     * @var int : numeric (1), associative (2), both (3)
     * @access public
     */
    var $return_as = 2;

    /**
     * Return a single dimensional array, object or other type when
     * a result query have only one row.
     *
     * @var boolean
     * @access public
     */
    var $single_type = true;

    /**#@+
     * END DB Configuration Section
     *
     * DB Local References:
     *
     * @access private
     */

    /**
     * Database Connection Host ID
     */
    private $_dbid;
    
    /**
     * Database Connection ID
     */
    private $_dbase_id;
    
    /**
     * Standar Query ID
     */
    private $_query_id;
    
    /**
     * Connect to Database Server Host
     *
     * @param  string : host name (generally 'localhost')
     * @param  string : user server
     * @param  string : password user
     * @access public
     * @return void
     * @since  v. 1.0
     */
    function connect($host = "", $user = "", $password = "")
    {
        $_string_code = '$this->_dbid = @' . DB_CONNECT . '($host, $user, $password);';     // Building the dynamic connection code string
            eval($_string_code);                                                            // Send to Eval Function
	
        if ($this->_dbid === false) {
            trigger_error(DB_DISPLAY_NAME . " Error: the class driver can not be connect to database server host.", E_USER_ERROR);
            exit;
        }
	
    }
    
    private function do_query()
    {
    }
    
    /**
     * Receive a query and execute.  This function help itself for optimize
     * the queries.  Permite to receive any params num.  This, don't means that
     * execute multiple queries, else to be part of dynamic query build.
     *
     * @param  multiple
     * @access public
     * @return resource | array | object
     * @since  v. 1.0
     */
    function execute()
    {
        // Verifing if none params exists.

        if (func_num_args() == 0) {
            trigger_error(DB_DISPLAY_NAME . " Execution Error: you can't a empty query to execute", E_USER_WARNING);
            return false;
        }
    
        $query = func_get_arg(0);           // Thinking in a pure query string.
		
        if (func_num_args() > 1) {
        } else
            $query = $this->_scape_query($query);
        
        $_string_code = '$this->_query_id = @' . DB_QUERY . '($query, $this->_dbid);';
            eval($_string_code);
		
        return $this->_return_type($this->_query_id);
    }
    
    /**
     * Return the specified result var type
     *
     * @param  resource
     * @access public
     * @return array (generally)
     * @since  v. 1.0
     */
    private function _return_type($resource_id)
    {
        if (gettype($resource_id) == "boolean")
            return $resource_id;
        else {

            // Return as Resource ID
        
            if ($this->return_type == 1) return $resource_id;
            
            $return       = array();
            $_fetch_type  = ($this->return_type == 2) ? DB_FETCH_ARRAY : DB_FETCH_OBJECT;
            $_array_type  = ($this->return_as   == 1) ? DB_CONST_NUM   : ($this->return_as == 2) ? DB_CONST_ASSOC : DB_CONST_BOTH;

            // Return as Array or Object

            if ($this->return_type == 2)
                $_string_code = 'while ($return[] = ' . $_fetch_type . '($resource_id, $_array_type));';
            else
                $_string_code = 'while ($return[] = ' . $_fetch_type . '($resource_id));';
                
                eval($_string_code);

            // Adjust the last record (possibly exists a bug in MySQL)
                
            if ($return[count($return) - 1] == NULL) unset($return[count($return) - 1]);
                
            if ($this->single_type == false)
                return $return;
            else
                if (count($return) > 1)
                    return $return;
                else {
                    if (count($return[0]) > 1)
                        return $return[0];
                    else {
                        if (gettype($return[0]) != "array")
                            return $return[0];
                        else {
                            $key = array_keys($return[0]);
                            return $return[0][$key[0]];
                        }
                    }
                }
        }
    }
    
    private function _scape_query($query, $quit_delims = false)
    {
        $_group_chars = '"' . "'";                                      // Groups Characters " and '

        if ($quit_delims == true) {
            $query    = str_replace(DB_SECTION_DELIM_LEFT, "", $query);
            $query    = str_replace(D);
        }
		
		return $query;
    }
}
?>
