<?php
	/**
	  * En este ejemplo coloque todas las funciones que utilizara el archivo cliente, en el archivo de dependencia.  Aui, solamente
	  * generar la salida.  Construyo una estructura de control SWITCH.  Todos los parmetros sern via GET.  Esto es solo un
	  * ejemplo ilustrativo para demostrar la divisin enre niveles.  
	  */
	require "require.php";
	
	switch ($_GET["table"]) {
		case "cliente":
			switch ($_GET["cmd"]) {
				case "list":
					$list = ( list_clients() );
				
					// Ahora, vamos a generar la salida en formato XML.  Podemos enviar todo o solo una parte.
					
					header("Content-Type: text/xml");
					echo '<?xml version = "1.0" ?>';
					echo '<list>';
						foreach ($list as $row) {
							echo '<client id = "' . $row["id"] . '">';
								echo '<name>' . $row["nombre"] . '</name>';
								echo '<address>' . $row["direccion"] . '</address>';
								echo '<phone>' . $row["telefono"] . '</phone>';
							echo '</client>';
						}
					echo '</list>';
					
					// Posteriormente, para mostrar la informacin, podemos usar siempre el mismos lenguaje del lado del
					// Servidor o parsear el XML con JavaScript o XSL
				
					break;
					
				case "agregar":
					header("Content-Type: text/plain");
						echo "STATUS: ";
						echo (create_client( $_GET["name"], $_GET["address"], $_GET["phone"] )) ? 1 : 0;
					break;
				case "editar":
					header("Content-Type: text/plain");
						echo "STATUS: ";
						echo (edit_client( $_GET["id"],  $_GET["name"], $_GET["address"], $_GET["phone"] )) ? 1 : 0;
					break;
				case "eliminar":
					header("Content-Type: text/plain");
						echo "STATUS: ";
						echo (del_client( $_GET["id"] )) ? 1 : 0;
					break;
			}
		break;
	
	}
	
	/**
	 * El anterior esquema es bastante sencillo y no es tan optimizado como podra llegar a ser.  Lo impartante es que se muestra que si se puede dividir la carga
	 * entre el SGBD y el lenguaje de programacin.  Puede revisarse el codigo  y se ver que no hay una sola sentencia o parte de una sentencia presente.  Solamente,
	 * se hace referencia a codigos que sabremos que representan la consulta al SGBD y los cdigos que nos devuelve la Base de Datos.  No estamos adivinando
	 * cuales son, sino que sabemos que son esos los que llegarn.  Debemos trabajar en una estructura estndard de envio y recepcin de datos, sea cual sea
	 * nuestra Base de Datos.
	 */
	 
	/**
	 * El script de ejemplo, puede resultar un tanto redundante, pero ser bueno para demostrar la eficacia de lo que se propone sin desconcertar al lector.
	 */
?>