<?php
# En este ejemplo, veremos de una manera muy sencilla, como se creara una estructura base de lgica de programacin.
# Existen muchas formas de desarrollar.  Creo que dependiendo de los componentes, es bueno hacerlo con clases y muy
# bien organizado.  Pero, en este ejemplo, he decidido desarrollarlo en su mayora en un solo script y sin clases.  Debo
# indicar, que esta no es la manera ms optima para desarrollar.  Solo es para propsitos ilustrativos.

	#  Cargamos los archivos de dependencia general
	include "yaml/spyc.php";	// <-- YAML Parser
	
	# Estos archivos me permitiran conectarme a la base de datos, de manera transparente para mi script.  En el ejemplo
	# final, pueden ver la implementacin de estos dos scripts.  An no estn completados del todo, pero para el ejemplo
	# son perfectamente funcionales.  La tcnica utilizada en estos, es muy optimizada y sencilla de extender.
	include "db.php";				
		include "mysql.php";

	# Carga a un Array, todos los queries desde el archivo YAML.  Solo para propsitos ilustrativos.  Esto puede hacerse
	# en mdulos y cargando solo ciertas partes del archivo.
	
	function load_query($_file)  { $GLOBALS["QUERY"] = Spyc::YAMLLoad($_file); }
	function return_query($code) { return $GLOBALS["QUERY"][$code]; }
	
	# Conectando a la BD
	
	$GLOBALS["mysql"] = new mysql();
	
	// --> !!!! Nunca se conecten a la BD como usuario Root.  Esto es solo para propsitos ilustrativos.
	$GLOBALS["mysql"]->connect("localhost", "root", "");	
	
	function exec_query($query)
	{
		return $GLOBALS["mysql"]->execute($query);
	}
	
	/**
	 * El ejemplo de abajo ilustra de una manera sencilla que con componenetes reutilizables, podemos armas funciones
	 * avanzadas con unas pocas lneas de cdigo.  El ejemplo ya cargo el archivo DB:YAML, donde estn nuestros
	 * queries, ha utilizar para conectarnos a la BD.
	 *
	load_query("db.yaml");
	echo return_query("L9T6");
	/**/
	
	load_query("db.yaml");			// <-- Cargando los queries a utilizar
	
		exec_query( return_query ("JM86") );		// <-- Especificando que se utilizar la base de datos de Prueba: MW (Maestros del Web)
	
	/**
	 * Ejemplo clasico: Ejecutando el query AR56:  SELECT * FROM `_clientes`
	 *
	print_r( exec_query( return_query ("AR56") ) );
	/**/
	
	/**
	  * Funciones que utilizan las vistas generadas.
	  */
	
	function list_clients() { return exec_query( return_query ("AR56") ); }
	function list_debtors() { return exec_query( return_query ("46TY") ); }
	
	// La funcin permite listar todas las facturas o solamente aquellas para un determinado cliente.
	
	function list_bills($client = NULL) 
	{ 
		$query = return_query ("JK7T");
		
		if ($client != NULL) $query = str_replace("%id_cte%", $client, return_query("JK7U"));
	
		return exec_query( $query ); 
	}
	
	/**
	 * Otras funciones para clientes
	 */
	 
	function create_client($name, $address, $phone)
	{
		$result = exec_query( str_replace(array("%nombre%", "%direccion%", "%telefono%"), array($name, $address, $phone), return_query( "L9T6" ) ) );
		
		return ($result == "7892");
	}
	
	// var_dump(create_client("miguel hernandez", "guatemala", "1234-5678"));
	
	function edit_client($client_code, $name, $address, $phone)
	{
		$result = exec_query( str_replace(array("%codigo_cliente%", "%nombre%", "%direccion%", "%telefono%"), array($client_code, $name, $address, $phone), return_query( "MY8O" ) ) );
		
		return ($result == "4562");
	}
	
	// var_dump(edit_client("13", "juan miguel hernandez", "guatemala", "1234-5678"));
	
	function del_client($client_code) { return exec_query( str_replace(array("%codigo_cliente%"), array($client_code), return_query( "KJTR" ) ) ); }
	
	
?>